明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2069|回复: 9

[求助]请帮忙编一个“在CAD图里将选定数值加一个常量”的程序

[复制链接]
发表于 2005-1-20 11:36:00 | 显示全部楼层 |阅读模式
由于设计变更,需将CAD图里的大量高程数据(或选定的数据)加上一个常数(正负数或零),并将计算结果替换原数据。要求能够区分正负数值,即进行代数运算。
当然,双击修改也可以,但速度比较慢。所以想快捷一些。
例:
原数据:23.507
希望在23.507的基础上加1.2,得到结果:24.707,并替换原数据。



恭请各位大侠帮忙!!在此先谢谢各位!!!
发表于 2005-1-20 15:41:00 | 显示全部楼层
;本程序将指定数字增加一量值
(defun c:incr( / sset ct num ed ent temp temp1 value)
(princ "\nDecrease the value of selected text, Version 1.0, (c) 1999 by Z.L.Wang")
(prompt "\nSelect text to change: ")
(setq sset (ssget '((0 . "TEXT"))))
(if (null sset)
(progn
(princ "\nNothing selected.")
(exit)
)
)
(setq value (getreal "Input the value to decrease: "))
(setq ct 0)
(setq num (sslength sset))
(repeat num
(setq ent (ssname sset ct))
(setq ed(entget ent))
(setq temp (assoc 1 ed))
(setq temp1 (atof (cdr temp)))
(setq temp1 (+ temp1 value))
(setq temp (rtos temp1 2 3))
(setq ed (subst (cons 1 temp) (assoc 1 ed) ed))
(entmod ed)
(setq ct (+ 1 ct))
)
)
回复 支持 1 反对 0

使用道具 举报

发表于 2005-1-20 11:47:00 | 显示全部楼层
Are all the data text to be selected on an isolated layer? You'd better attached your drawing here.
发表于 2005-1-21 12:18:00 | 显示全部楼层
可以将选择的text的图元名转换为表,用MAPCAR取得文本内容list,并加1.2,然后subst应该不难实现
 楼主| 发表于 2006-1-11 09:42:00 | 显示全部楼层
xiaomihu发表于2005-1-20 15:41:00;本程序将指定数字增加一量值(defun c:incr( / sset ct num ed ent temp temp1 value)   (princ \"\nDecrease the value of selected text, Version 1.0,...

多谢!!!虽然过去很久了,但一直没有言谢,不好意思
发表于 2012-12-6 16:40:26 | 显示全部楼层
请问 2楼那个程序 怎么使用??在CAD里直接输入?试了下不会用!求指导

点评

2楼没程序呀?是三楼的吧。加载后键入INCR。  发表于 2012-12-6 17:28
发表于 2015-9-3 12:14:36 | 显示全部楼层
谢谢XIAOMIHU
发表于 2015-9-3 14:32:10 | 显示全部楼层
本帖最后由 zhd81617 于 2015-9-3 14:46 编辑
xiaomihu 发表于 2005-1-20 15:41
;本程序将指定数字增加一量值(defun c:incr( / sset ct num ed ent temp temp1 value)                 (princ "\nDecreas ...

请问哪里可以控制小数点的位数啊,例如,希望结果为一位数1.0;或者是两位数1.00

已经解决了。
发表于 2015-9-7 23:22:41 | 显示全部楼层
xiaomihu 发表于 2005-1-20 15:41
;本程序将指定数字增加一量值(defun c:incr( / sset ct num ed ent temp temp1 value)                 (princ "\nDecreas ...

这个不错,值得拥有!谢谢!
发表于 2024-8-3 10:21:34 | 显示全部楼层
xiaomihu 发表于 2005-1-20 15:41
;本程序将指定数字增加一量值(defun c:incr( / sset ct num ed ent temp temp1 value)                 (princ "\nDecreas ...

谢谢分享!好工具!!!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 11:55 , Processed in 0.188584 second(s), 29 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表